module MainTree where

import SetTree
import Test.QuickCheck
import List(nub,sort)

prop_insert :: Int -> Int -> [Int] -> Bool
prop_insert x y xs  =
  x `element` (insert y s)  ==  (x == y || x `element` s)
  where
  s = set xs

prop_list :: [Int] -> Bool
prop_list xs  =  list (set xs)  ==  nub (sort xs)

prop_delete :: Int -> Int -> [Int] -> Bool
prop_delete x y xs  =
  x `element` (delete y s)  ==  (x /= y && x `element` s)
  where
  s = set xs

main =
  quickCheck prop_insert >>
  quickCheck prop_list >>
  quickCheck prop_delete
