module SetList(Set,element,nil,insert,set,list,each,subset,equal,delete) where
import List(nub,sort)

data  Set a  =  MkSet [a]

element :: Eq a => a -> Set a -> Bool
x `element` (MkSet xs)  =  elem x xs

nil :: Set a
nil =  MkSet []

insert :: a -> Set a -> Set a
insert x (MkSet xs)  =  MkSet (x:xs)

set :: [a] -> Set a
set =  foldr insert nil

list :: Ord a => Set a -> [a]
list (MkSet xs)  =  nub (sort xs)

each :: Set a -> (a -> Bool) -> Bool
each (MkSet xs) p  =  and [ p x | x <- xs ]

subset :: Eq a => Set a -> Set a -> Bool
s `subset` t  =  each t (`element` s)

equal :: Eq a => Set a -> Set a -> Bool
s `equal` t  =  s `subset` t && t `subset` s

delete :: Eq a => a -> Set a -> Set a
delete x (MkSet xs)  =  MkSet [ y | y <- xs, x /= y ]

showRep :: Show a => Set a -> String
showRep (MkSet xs)  =  "MkSet " ++ show xs

test0 :: Bool
test0 =
  2 `element` s0 &&
  not (3 `element` s0) &&
  showRep s0 == "MkSet [2,7,1,8,2,8]"
  where
  s0 = set [2,7,1,8,2,8]



