module SetTree(Set,element,nil,insert,set,list,each,subset,equal,delete) where

data  Set a  =  Nil | Node (Set a) a (Set a)

element :: Ord a => a -> Set a -> Bool
x `element` Nil  =  False
x `element` (Node l y r)
  | x == y     =  True
  | x < y      =  x `element` l
  | x > y      =  x `element` r

nil :: Set a
nil  =  Nil

insert :: Ord a => a -> Set a -> Set a
insert x Nil  =  Node Nil x Nil
insert x (Node l y r)
  | x == y     =  Node l y r
  | x < y      =  Node (insert x l) y r
  | x > y      =  Node l y (insert x r)

set :: Ord a => [a] -> Set a
set  =  foldr insert nil

list :: Set a -> [a]
list Nil           =  []
list (Node l x r)  =  list l ++ [x] ++ list r

each :: Set a -> (a -> Bool) -> Bool
each s p  =  and [ p x | x <- list s ]

subset :: Ord a => Set a -> Set a -> Bool
s `subset` t  =  each t (`element` s)

equal :: Ord a => Set a -> Set a -> Bool
s `equal` t  =  s `subset` t && t `subset` s

delete :: Ord a => a -> Set a -> Set a
delete x Nil  =  Nil
delete x (Node l y r)
  | x == y    =  join l r
  | x < y     =  Node (delete x l) y r
  | x > y     =  Node l y (delete x r)

join :: Ord a => Set a -> Set a -> Set a
join l Nil    =  l
join l r      =  Node l x (delete x r)
  where
  x = smallest r

smallest :: Ord a => Set a -> a
smallest (Node Nil y r)  =  y
smallest (Node l y r)    =  smallest l

showRep :: Show a => Set a -> String
showRep Nil	      =  "Nil"
showRep (Node l x r)  =  "(Node " ++ showRep l
                           ++ " " ++ show x
                           ++ " " ++ showRep r ++ ")"

test0 :: Bool
test0 =
  2 `element` s0 &&
  not (3 `element` s0) &&
  showRep s0 ==
      "(Node (Node (Node Nil 1 Nil) 2 (Node Nil 7 Nil)) 8 Nil)"
  where
  s0 = set [2,7,1,8,2,8]







